namespace StudySystemClient {
	const string title = "Study System Client";

	public class MainWindow : Gtk.ApplicationWindow {
		private Connection connection;
		private Gtk.Button send_button;
		private Gtk.Label response_label;

		public MainWindow(Gtk.Application app, Connection connection) {
			Object(application: app);

			default_width = 360;
			default_height = 580;

			this.connection = connection;
			connection.response_received.connect((response) => {
					response_label.label = "Response: " + (string)response;
				});

			var box = new Gtk.Box(Gtk.Orientation.VERTICAL, 10);
			box.margin_start = 10;
			box.margin_end = 10;
			box.margin_top = 10;
			box.margin_bottom = 10;

			send_button = new Gtk.Button.with_label("Send");
			send_button.clicked.connect(on_send_clicked);
			box.append(send_button);

			response_label = new Gtk.Label("");
			response_label.wrap = true;
			box.append(response_label);

			set_child(box);

			present();
		}

		private async void on_send_clicked() {
			try {
				yield connection.send("Foo".data);
			} catch (Error e) {
				response_label.label = "Error: " + e.message;
			}
		}
	}
}
